import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;

import javax.swing.JFrame;

public class SkyMain {

    public static void main(String[] args)
    {
        GraphicsEnvironment ge = GraphicsEnvironment
                .getLocalGraphicsEnvironment();
        GraphicsDevice[] gs = ge.getScreenDevices();
        DisplayMode newDisplayMode = new DisplayMode(800, 600, 32, 0);
        GraphicsDevice de = ge.getDefaultScreenDevice();

        SkyHawkEngine skyEn = new SkyHawkEngine();
        skyEn.setUndecorated(false); // eliminate borders
        DisplayMode oldDisplayMode = de.getDisplayMode(); // set full screen

        if (de.isFullScreenSupported()) {
            de.setFullScreenWindow(skyEn);
            de.setDisplayMode(newDisplayMode);
        } else {
            de.setFullScreenWindow(null);
            de.setDisplayMode(oldDisplayMode);// Full screen not supported
        }

        try {
            skyEn.initialize();
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("WHAT HAVE U DONE!!! \n"
                    + "ERROR ON MAIN INITIALIZE, CHECK GFX AND SFX FILES !!!");
        }

        skyEn.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    }
}
